@ECHO off
REM R-Shake UPG1 installer
REM windows version

REM If setting this variable, you must ensure at least two things:
REM   1) enclose all of it in double quotes
REM   2) terminate the path with a final backslash \ to close the directory
REM An example entry might look like:
REM SET WINSCPDIR="C:\Program Files (X86)\winscp\"

SET WINSCPDIR="C:\Program Files (x86)\WinSCP\"

REM UPG.1 remote installer script
REM get some info from the user
ECHO.
ECHO Raspberry Shake Upgrader - Ver0 to Ver1
ECHO This installer assumes WINscp is in your PATH variable.
ECHO More detailed output can be found in file rsh-upgrade.txt in this same directory.
ECHO If this is not the case, please edit this file, define the location of the WINscp executables on Line 11, 
ECHO And run this again...
ECHO.
ECHO You will need two pieces of information to complete this:
ECHO   1) The local IP address of the Raspberry Shake unit to update, and
ECHO   2) The current password of the myshake user
timeout /t -1

ECHO.
SET /p ipaddr="What is the IP address of the r-shake:		"
SET /p pword="What is the password of the myshake user:	"

REM variables
SET Wcmd=%WINSCPDIR%winscp.com /command
SET machcred=sftp://myshake:%pword%@%ipaddr%
SET DLDIR=/opt/DL/
SET tarF=rsh-upg1.tar
SET UPGDIR=UPG.1
SET cmd=rsh-upgrade.sh
SET log=rsh-upgrade.txt 2>&1

REM verify connection and allow user to answer Q on first-time connect
ECHO Verifying connection...
ECHO.
ECHO Verifying connection: >>%log%
%Wcmd% ^
	"open %machcred% -hostkey=*" ^
	"exit"
IF ERRORLEVEL 1 (
	ECHO Connection verification failed, cannot continue...
	ECHO Please check the IP address and password and try again.
	timeout /t -1
	EXIT /B
)

REM get the current version over there and verify it's at zero
ECHO Verifying current version...
SET VER=ver.0
SET VERFILE=/opt/settings/sys/%VER%
ECHO Fetching version file: >>%log%
%Wcmd% ^
	"open %machcred%" ^
	"get %VERFILE%" ^
	"exit" >>%log%
IF NOT EXIST %VER% (
	ECHO Raspberry Shake Unit %ipaddr% has already been updated, no need to update again
	ECHO Quitting without doing anything, goodbye...
	timeout /t -1
	EXIT /B
)
del %VER%
ECHO Version verified, issuing update commands...
ECHO.

REM copy over the installer and files
ECHO. >>%log%
ECHO Copying over installer: >>%log%
ECHO Copying over Installer...
%Wcmd% ^
	"open %machcred%" ^
	"put %tarF% %DLDIR%" ^
	"exit" >>%log%
%Wcmd% ^
	"open %machcred%" ^
	"cd %DLDIR%" ^
	"call tar xf %tarF%" ^
	"exit" >>%log%
IF ERRORLEVEL 1 (
	ECHO File copy to the r-shake failed, cannot continue...
	ECHO Please check the IP address and password and try again.
	timeout /t -1
	EXIT /B
)

REM execute installer
ECHO. >>%log%
ECHO Running installer: >>%log%
ECHO Running Installer...
%Wcmd% ^
	"open %machcred%" ^
	"cd %DLDIR%/%UPGDIR%" ^
	"call ./%cmd%" ^
	"exit" >>%log%
IF ERRORLEVEL 1 (
	ECHO File copy to the r-shake failed, cannot continue...
	ECHO Please check the IP address and password and try again.
	timeout /t -1
	EXIT /B
)

REM cleanup
ECHO. >>%log%
ECHO Removing installer: >>%log%
ECHO Removing Installer...
%Wcmd% ^
	"open %machcred%" ^
	"cd %DLDIR%" ^
	"call rm -r %UPGDIR% %tarF%" ^
	"exit" >>%log%

REM reboot
ECHO. >>%log%
ECHO Rebooting: >>%log%
ECHO Issuing reboot command, you may need to wait...
%Wcmd% ^
	"open %machcred%" ^
	"call sudo reboot" ^
	"exit" >>%log%

ECHO.
ECHO Successfully Updated
ECHO Your Raspberry Shake is now rebooting...
timeout /t -1

EXIT /B